"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var __1 = require("..");
var body_1 = __importDefault(require("./body"));
var caption_1 = __importDefault(require("./caption"));
var filters_1 = __importDefault(require("./filters"));
var footer_1 = __importDefault(require("./footer"));
var header_1 = __importDefault(require("./header"));
var props_resolver_1 = __importDefault(require("./props-resolver"));
var utils_1 = __importDefault(require("./utils"));
var BootstrapTable = /*#__PURE__*/function (_ref) {
  _inherits(BootstrapTable, _ref);
  var _super = _createSuper(BootstrapTable);
  function BootstrapTable(props) {
    var _this;
    _classCallCheck(this, BootstrapTable);
    _this = _super.call(this, props);
    // Exposed APIs
    _this.getData = function () {
      return _this.visibleRows();
    };
    _this.validateProps();
    return _this;
  }
  _createClass(BootstrapTable, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(nextProps) {
      if (nextProps.onDataSizeChange && !nextProps.pagination) {
        if (nextProps.data.length !== this.props.data.length) {
          nextProps.onDataSizeChange({
            dataSize: this.props.data.length
          });
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        loading = _this$props.loading,
        overlay = _this$props.overlay;
      if (overlay) {
        var LoadingOverlay = overlay(loading);
        return react_1["default"].createElement(LoadingOverlay, null, this.renderTable());
      }
      return this.renderTable();
    }
  }, {
    key: "renderTable",
    value: function renderTable() {
      var _this$props2 = this.props,
        columns = _this$props2.columns,
        keyField = _this$props2.keyField,
        tabIndexCell = _this$props2.tabIndexCell,
        id = _this$props2.id,
        classes = _this$props2.classes,
        _this$props2$bootstra = _this$props2.bootstrap4,
        bootstrap4 = _this$props2$bootstra === void 0 ? false : _this$props2$bootstra,
        _this$props2$striped = _this$props2.striped,
        striped = _this$props2$striped === void 0 ? false : _this$props2$striped,
        _this$props2$hover = _this$props2.hover,
        hover = _this$props2$hover === void 0 ? false : _this$props2$hover,
        _this$props2$bordered = _this$props2.bordered,
        bordered = _this$props2$bordered === void 0 ? true : _this$props2$bordered,
        _this$props2$condense = _this$props2.condensed,
        condensed = _this$props2$condense === void 0 ? false : _this$props2$condense,
        _this$props2$noDataIn = _this$props2.noDataIndication,
        noDataIndication = _this$props2$noDataIn === void 0 ? null : _this$props2$noDataIn,
        caption = _this$props2.caption,
        rowStyle = _this$props2.rowStyle,
        rowClasses = _this$props2.rowClasses,
        wrapperClasses = _this$props2.wrapperClasses,
        rowEvents = _this$props2.rowEvents,
        _this$props2$selectRo = _this$props2.selectRow,
        selectRow = _this$props2$selectRo === void 0 ? {
          mode: __1.ROW_SELECT_DISABLED,
          selected: [],
          hideSelectColumn: true
        } : _this$props2$selectRo,
        _this$props2$expandRo = _this$props2.expandRow,
        expandRow = _this$props2$expandRo === void 0 ? {
          renderer: undefined,
          expanded: [],
          nonExpandable: []
        } : _this$props2$expandRo,
        _this$props2$cellEdit = _this$props2.cellEdit,
        cellEdit = _this$props2$cellEdit === void 0 ? {
          mode: null,
          nonEditableRows: []
        } : _this$props2$cellEdit,
        _this$props2$filterPo = _this$props2.filterPosition,
        filterPosition = _this$props2$filterPo === void 0 ? __1.FILTERS_POSITION_INLINE : _this$props2$filterPo;
      var tableWrapperClass = (0, classnames_1["default"])("react-bootstrap-table", wrapperClasses);
      var tableClass = (0, classnames_1["default"])("table", _defineProperty({
        "table-striped": striped,
        "table-hover": hover,
        "table-bordered": bordered
      }, bootstrap4 ? "table-sm" : "table-condensed", condensed), classes);
      var hasFilters = columns.some(function (col) {
        return col.filter || col.filterRenderer;
      });
      var hasFooter = utils_1["default"].filter(columns, function (col) {
        return utils_1["default"].has(col, "footer");
      }).length > 0;
      var tableCaption = caption && react_1["default"].createElement(caption_1["default"], {
        bootstrap4: bootstrap4
      }, caption);
      return react_1["default"].createElement("div", {
        className: tableWrapperClass
      }, react_1["default"].createElement("table", {
        id: id,
        className: tableClass
      }, tableCaption, react_1["default"].createElement(header_1["default"], {
        columns: columns,
        className: this.props.headerClasses,
        wrapperClasses: this.props.headerWrapperClasses,
        sortField: this.props.sortField,
        sortOrder: this.props.sortOrder,
        onSort: this.props.onSort,
        globalSortCaret: this.props.sort && this.props.sort.sortCaret,
        onFilter: this.props.onFilter,
        currFilters: this.props.currFilters,
        onExternalFilter: this.props.onExternalFilter,
        selectRow: selectRow,
        expandRow: expandRow,
        filterPosition: filterPosition
      }), hasFilters && filterPosition !== __1.FILTERS_POSITION_INLINE && react_1["default"].createElement(filters_1["default"], {
        columns: columns,
        className: this.props.filtersClasses,
        onSort: this.props.onSort,
        onFilter: this.props.onFilter,
        currFilters: this.props.currFilters,
        filterPosition: this.props.filterPosition,
        onExternalFilter: this.props.onExternalFilter,
        selectRow: selectRow,
        expandRow: expandRow
      }), react_1["default"].createElement(body_1["default"], {
        className: this.props.bodyClasses,
        data: this.getData(),
        keyField: keyField,
        tabIndexCell: tabIndexCell,
        columns: columns,
        isEmpty: this.isEmpty(),
        visibleColumnSize: this.visibleColumnSize(),
        noDataIndication: noDataIndication,
        cellEdit: cellEdit,
        selectRow: selectRow,
        expandRow: expandRow,
        rowStyle: rowStyle,
        rowClasses: rowClasses,
        rowEvents: rowEvents
      }), hasFooter && react_1["default"].createElement(footer_1["default"], {
        data: this.getData(),
        columns: columns,
        selectRow: selectRow,
        expandRow: expandRow,
        className: this.props.footerClasses
      })));
    }
  }]);
  return BootstrapTable;
}((0, props_resolver_1["default"])(react_1["default"].Component));
exports["default"] = BootstrapTable;