"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var react_1 = __importDefault(require("react"));
var utils_1 = __importDefault(require("./utils"));
var FiltersCell = function FiltersCell(props) {
  var index = props.index,
    column = props.column,
    currFilters = props.currFilters,
    _props$onExternalFilt = props.onExternalFilter,
    onExternalFilter = _props$onExternalFilt === void 0 ? function () {} : _props$onExternalFilt,
    _props$onFilter = props.onFilter,
    onFilter = _props$onFilter === void 0 ? function () {} : _props$onFilter;
  var filter = column.filter;
  var filterElm;
  var cellAttrs = {};
  var cellStyle = {};
  cellAttrs.style = cellStyle;
  if (column.headerAlign) {
    cellStyle.textAlign = utils_1["default"].isFunction(column.headerAlign) ? column.headerAlign(column, index) : column.headerAlign;
  }
  if (column.filterRenderer) {
    var onCustomFilter = onExternalFilter(column, (filter === null || filter === void 0 ? void 0 : filter.props.type) || "");
    filterElm = column.filterRenderer(onCustomFilter, column);
  } else if (filter) {
    filterElm = react_1["default"].createElement(filter.Filter, Object.assign({}, filter.props, {
      filterState: currFilters[column.dataField],
      onFilter: onFilter,
      column: column
    }));
  }
  return react_1["default"].createElement("th", cellAttrs, filterElm);
};
exports["default"] = FiltersCell;