"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var react_1 = __importDefault(require("react"));
var __1 = require("..");
var header_cell_1 = __importDefault(require("./header-cell"));
var expand_header_cell_1 = __importDefault(require("./row-expand/expand-header-cell"));
var expand_header_cell_consumer_1 = __importDefault(require("./row-expand/expand-header-cell-consumer"));
var selection_header_cell_1 = __importDefault(require("./row-selection/selection-header-cell"));
var selection_header_cell_consumer_1 = __importDefault(require("./row-selection/selection-header-cell-consumer"));
var Header = function Header(props) {
  var className = props.className,
    columns = props.columns,
    onSort = props.onSort,
    onFilter = props.onFilter,
    sortField = props.sortField,
    sortOrder = props.sortOrder,
    selectRow = props.selectRow,
    expandRow = props.expandRow,
    currFilters = props.currFilters,
    onExternalFilter = props.onExternalFilter,
    filterPosition = props.filterPosition,
    globalSortCaret = props.globalSortCaret,
    wrapperClasses = props.wrapperClasses;
  var SelectionHeaderCellComp = function SelectionHeaderCellComp() {
    return null;
  };
  var ExpansionHeaderCellComp = function ExpansionHeaderCellComp() {
    return null;
  };
  if (expandRow === null || expandRow === void 0 ? void 0 : expandRow.showExpandColumn) {
    ExpansionHeaderCellComp = (0, expand_header_cell_consumer_1["default"])(expand_header_cell_1["default"]);
  }
  if (selectRow) {
    SelectionHeaderCellComp = (0, selection_header_cell_consumer_1["default"])(selection_header_cell_1["default"]);
  }
  var isRenderFunctionColumnInLeft = function isRenderFunctionColumnInLeft() {
    var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : __1.INDICATOR_POSITION_LEFT;
    return position === __1.INDICATOR_POSITION_LEFT;
  };
  var childrens = columns.map(function (column, i) {
    var currSort = column.dataField === sortField;
    var isLastSorting = column.dataField === sortField;
    return react_1["default"].createElement(header_cell_1["default"], {
      index: i,
      key: column.dataField,
      column: column,
      onSort: onSort,
      sorting: currSort,
      sortOrder: sortOrder,
      globalSortCaret: globalSortCaret,
      isLastSorting: isLastSorting,
      onFilter: onFilter,
      currFilters: currFilters,
      onExternalFilter: onExternalFilter,
      filterPosition: filterPosition
    });
  });
  if (selectRow && !selectRow.hideSelectColumn) {
    if (isRenderFunctionColumnInLeft(selectRow.selectColumnPosition)) {
      childrens.unshift(react_1["default"].createElement(SelectionHeaderCellComp, {
        key: "selection"
      }));
    } else {
      childrens.push(react_1["default"].createElement(SelectionHeaderCellComp, {
        key: "selection"
      }));
    }
  }
  if (expandRow === null || expandRow === void 0 ? void 0 : expandRow.showExpandColumn) {
    if (isRenderFunctionColumnInLeft(expandRow.expandColumnPosition)) {
      childrens.unshift(react_1["default"].createElement(ExpansionHeaderCellComp, {
        key: "expansion"
      }));
    } else {
      childrens.push(react_1["default"].createElement(ExpansionHeaderCellComp, {
        key: "expansion"
      }));
    }
  }
  return react_1["default"].createElement("thead", {
    className: wrapperClasses
  }, react_1["default"].createElement("tr", {
    className: className
  }, childrens));
};
exports["default"] = Header;