"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var events_1 = __importDefault(require("events"));
var react_1 = require("react");
var utils_1 = __importDefault(require("../utils"));
exports["default"] = function (ExtendBase) {
  return /*#__PURE__*/function (_react_1$Component) {
    _inherits(RemoteResolver, _react_1$Component);
    var _super = _createSuper(RemoteResolver);
    function RemoteResolver(props) {
      var _this;
      _classCallCheck(this, RemoteResolver);
      _this = _super.call(this, props);
      _this.getNewestState = function () {
        var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var sortOrder;
        var sortField;
        var page;
        var sizePerPage;
        var searchText;
        var filters = {};
        if (_this.sortContext) {
          sortOrder = _this.sortContext.state.sortOrder;
          sortField = _this.sortContext.state.sortColumn ? _this.sortContext.state.sortColumn.dataField : null;
        }
        if (_this.filterContext) {
          filters = _this.filterContext.currFilters;
        }
        if (_this.paginationContext) {
          page = _this.paginationContext.currPage;
          sizePerPage = _this.paginationContext.currSizePerPage;
        }
        if (_this.searchContext) {
          searchText = _this.props.search.searchText;
        }
        return Object.assign(Object.assign({
          sortOrder: sortOrder,
          sortField: sortField,
          filters: filters,
          page: page,
          sizePerPage: sizePerPage,
          searchText: searchText
        }, state), {
          data: _this.props.data
        });
      };
      _this.isRemoteSearch = function () {
        var remote = _this.props.remote;
        return remote === true || utils_1["default"].isObject(remote) && remote.search || _this.isRemotePagination();
      };
      _this.isRemotePagination = function () {
        var e = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var remote = _this.props.remote;
        e.result = remote === true || utils_1["default"].isObject(remote) && remote.pagination;
        return e.result;
      };
      _this.isRemoteFiltering = function () {
        var remote = _this.props.remote;
        return remote === true || utils_1["default"].isObject(remote) && remote.filter || _this.isRemotePagination();
      };
      _this.isRemoteSort = function () {
        var remote = _this.props.remote;
        return remote === true || utils_1["default"].isObject(remote) && remote.sort || _this.isRemotePagination();
      };
      _this.isRemoteCellEdit = function () {
        var remote = _this.props.remote;
        return remote === true || utils_1["default"].isObject(remote) && remote.cellEdit;
      };
      _this.handleRemotePageChange = function (page, sizePerPage) {
        _this.props.onTableChange("pagination", _this.getNewestState({
          page: page,
          sizePerPage: sizePerPage
        }));
      };
      _this.handleRemoteFilterChange = function (filters) {
        var newState = {
          filters: filters
        };
        if (_this.isRemotePagination()) {
          var options = _this.props.pagination.options || {};
          newState.page = utils_1["default"].isDefined(options.pageStartIndex) ? options.pageStartIndex : 1;
        }
        _this.props.onTableChange("filter", _this.getNewestState(newState));
      };
      _this.handleRemoteSortChange = function (sortField, sortOrder) {
        _this.props.onTableChange("sort", _this.getNewestState({
          sortField: sortField,
          sortOrder: sortOrder
        }));
      };
      _this.handleRemoteCellChange = function (rowId, dataField, newValue) {
        var cellEdit = {
          rowId: rowId,
          dataField: dataField,
          newValue: newValue
        };
        _this.props.onTableChange("cellEdit", _this.getNewestState({
          cellEdit: cellEdit
        }));
      };
      _this.handleRemoteSearchChange = function (searchText) {
        _this.props.onTableChange("search", _this.getNewestState({
          searchText: searchText
        }));
      };
      _this.remoteEmitter = new events_1["default"]();
      _this.remoteEmitter.on("paginationChange", _this.handleRemotePageChange);
      _this.remoteEmitter.on("isRemotePagination", _this.isRemotePagination);
      return _this;
    }
    return _createClass(RemoteResolver);
  }(react_1.Component);
};