"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var row_expand_context_1 = __importDefault(require("../contexts/row-expand-context"));
var utils_1 = __importDefault(require("../utils"));
var expand_row_1 = __importDefault(require("./expand-row"));
var ExpansionContext = (0, row_expand_context_1["default"])();
exports["default"] = function (Component) {
  var renderWithExpansion = function renderWithExpansion(props, expandRow) {
    if (!expandRow) {
      return [];
    }
    var parentClassName = "";
    var className = "";
    var key = props.value;
    var expanded = utils_1["default"].contains(expandRow.expanded, key);
    var isClosing = utils_1["default"].contains(expandRow.isClosing, key);
    var expandable = !expandRow.nonExpandable || !utils_1["default"].contains(expandRow.nonExpandable, key);
    if (expanded) {
      parentClassName = utils_1["default"].isFunction(expandRow.parentClassName) ? expandRow.parentClassName(expanded, props.row, props.rowIndex) : expandRow.parentClassName || "";
      className = utils_1["default"].isFunction(expandRow.className) ? expandRow.className(expanded, props.row, props.rowIndex) : expandRow.className || "";
    }
    return [react_1["default"].createElement(Component, Object.assign({}, props, {
      key: key,
      expanded: expanded,
      expandable: expandable,
      expandRow: Object.assign({}, expandRow),
      className: (0, classnames_1["default"])(props.className, parentClassName)
    })), expanded || isClosing ? react_1["default"].createElement(expand_row_1["default"], {
      key: "".concat(key, "-expanding"),
      colSpan: props.visibleColumnSize,
      expanded: expanded,
      onClosed: function onClosed() {
        return expandRow.onClosed(key);
      },
      className: className
    }, expandRow.renderer(props.row, props.rowIndex)) : null];
  };
  return function (props) {
    return react_1["default"].createElement(ExpansionContext.Consumer, null, function (expandRow) {
      return renderWithExpansion(props, expandRow);
    });
  };
};